DCMTK: dcmtk::log4cplus::PropertyConfigurator Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
dcmtk::log4cplus::PropertyConfigurator Class Reference

Provides configuration from an external file. More...

Inheritance diagram for dcmtk::log4cplus::PropertyConfigurator:

## Public Member Functions
virtual void | configure ()
| Read configuration from a file.
log4cplus::helpers::Properties const & | getProperties () const
log4cplus::tstring const & | getPropertyFilename () const

## Static Public Member Functions
static void | doConfigure (const log4cplus::tstring &configFilename, Hierarchy &h=Logger::getDefaultHierarchy(), unsigned flags=0)
| This method eliminates the need to create a temporary `PropertyConfigurator` to configure log4cplus.

## Detailed Description

Provides configuration from an external file.

See configure() for the expected format.

All option values admit variable substitution. For example, if `userhome` environment property is set to `/home/xyz` and the File option is set to the string `${userhome}/test.log`, then File option will be interpreted as the string `/home/xyz/test.log`.

The syntax of variable substitution is similar to that of UNIX shells. The string between an opening "${" and closing "}" is interpreted as a key. Its value is searched in the environment properties. The corresponding value replaces the ${variableName} sequence.

## Member Function Documentation

## ◆ configure()

virtual void dcmtk::log4cplus::PropertyConfigurator::configure | ( |  | ) |
| virtual

Read configuration from a file.

The existing configuration is not cleared nor reset. If you require a different behavior, then call `resetConfiguration` method before calling `doConfigure`.

The configuration file consists of statements in the format `key=value`. The syntax of different configuration elements are discussed below.

### Appender configuration

Appender configuration syntax is:

    # For appender named appenderName, set its class.
    # Note: The appender name can contain dots.
    log4cplus.appender.appenderName=fully.qualified.name.of.appender.class

    # Set appender specific options.
    log4cplus.appender.appenderName.option1=value1
    ...
    log4cplus.appender.appenderName.optionN=valueN

For each named appender you can configure its `Layout`. The syntax for configuring an appender's layout is:

    log4cplus.appender.appenderName.layout=fully.qualified.name.of.layout.class
    log4cplus.appender.appenderName.layout.option1=value1
    ....
    log4cplus.appender.appenderName.layout.optionN=valueN

### Configuring loggers

The syntax for configuring the root logger is:

    log4cplus.rootLogger=[LogLevel], appenderName, appenderName, ...

This syntax means that an optional LogLevel value can be supplied followed by appender names separated by commas.

The LogLevel value can consist of the string values FATAL, ERROR, WARN, INFO, DEBUG or a custom LogLevel value.

If a LogLevel value is specified, then the root LogLevel is set to the corresponding LogLevel. If no LogLevel value is specified, then the root LogLevel remains untouched.

The root logger can be assigned multiple appenders.

Each appenderName (separated by commas) will be added to the root logger. The named appender is defined using the appender syntax defined above.

For non-root loggers the syntax is almost the same:

    log4cplus.logger.logger_name=[LogLevel|INHERITED], appenderName, appenderName, ...

The meaning of the optional LogLevel value is discussed above in relation to the root logger. In addition however, the value INHERITED can be specified meaning that the named logger should inherit its LogLevel from the logger hierarchy.

By default loggers inherit their LogLevel from the hierarchy. However, if you set the LogLevel of a logger and later decide that that logger should inherit its LogLevel, then you should specify INHERITED as the value for the LogLevel value.

Similar to the root logger syntax, each appenderName (separated by commas) will be attached to the named logger.

See the appender additivity rule in the user manual for the meaning of the `additivity` flag.

The user can override any of the `Hierarchy#disable` family of methods by setting the a key "log4cplus.disableOverride" to `true` or any value other than false. As in

    log4cplus.disableOverride=true

### Example

An example configuration is given below.

    # Set options for appender named "A1".
    # Appender "A1" will be a SyslogAppender
    log4cplus.appender.A1=log4cplus::SyslogAppender

    # The syslog daemon resides on www.abc.net
    log4cplus.appender.A1.SyslogHost=www.abc.net

    # A1's layout is a PatternLayout, using the conversion pattern
    # r %-5p c{2} M.L x - m

    . Thus, the log output will
    # include # the relative time since the start of the application in
    # milliseconds, followed by the LogLevel of the log request,
    # followed by the two rightmost components of the logger name,
    # followed by the callers method name, followed by the line number,
    # the nested diagnostic context and finally the message itself.
    # Refer to the documentation of PatternLayout for further information
    # on the syntax of the ConversionPattern key.
    log4cplus.appender.A1.layout=log4cplus::PatternLayout
    log4cplus.appender.A1.layout.ConversionPattern=%-4r %-5p c{2} M.L x - m

    # Set options for appender named "A2"
    # A2 should be a RollingFileAppender, with maximum file size of 10 MB
    # using at most one backup file. A2's layout is TTCC, using the
    # ISO8061 date format with context printing enabled.
    log4cplus.appender.A2=log4cplus::RollingFileAppender
    log4cplus.appender.A2.MaxFileSize=10MB
    log4cplus.appender.A2.MaxBackupIndex=1
    log4cplus.appender.A2.layout=log4cplus::TTCCLayout
    log4cplus.appender.A2.layout.ContextPrinting=enabled
    log4cplus.appender.A2.layout.DateFormat=ISO8601

    # Root logger set to DEBUG using the A2 appender defined above.
    log4cplus.rootLogger=DEBUG, A2

    # Logger definitions:
    # The SECURITY logger inherits is LogLevel from root. However, it's output
    # will go to A1 appender defined above. It's additivity is non-cumulative.
    log4cplus.logger.SECURITY=INHERIT, A1
    log4cplus.additivity.SECURITY=false

    # Only warnings or above will be logged for the logger "SECURITY.access".
    # Output will go to A1.
    log4cplus.logger.SECURITY.access=WARN

    # The logger "class.of.the.day" inherits its LogLevel from the
    # logger hierarchy.  Output will go to the appender's of the root
    # logger, A2 in this case.
    log4cplus.logger.class.of.the.day=INHERIT

Refer to the setOption method in each Appender and Layout for class specific options.

Use the `#` character at the beginning of a line for comments.

## ◆ doConfigure()

static void dcmtk::log4cplus::PropertyConfigurator::doConfigure | ( | const log4cplus::tstring & | configFilename,
|  | Hierarchy & | h = Logger::getDefaultHierarchy(),
|  | unsigned | flags = 0 )
| static

This method eliminates the need to create a temporary `PropertyConfigurator` to configure log4cplus.

It is equivalent to the following:
`PropertyConfigurator config("filename"); config.configure();`

References dcmtk::log4cplus::Logger::getDefaultHierarchy().

## ◆ getProperties()

log4cplus::helpers::Properties const & dcmtk::log4cplus::PropertyConfigurator::getProperties | ( |  | ) | const

Returns
  The return value is reference to Properties container of properties with the `"log4cplus."` prefix removed and references to other properties and/or environment variables expanded.

## ◆ getPropertyFilename()

log4cplus::tstring const & dcmtk::log4cplus::PropertyConfigurator::getPropertyFilename | ( |  | ) | const

Returns
  The return value is a reference to log4cplus::tstring containing filename of properties source file. It will be string "UNAVAILABLE" if the PropertyConfigurator instance has been constructed using one of the other constructors that do not take filename as parameter.

The documentation for this class was generated from the following file:

- oflog/include/dcmtk/oflog/configrt.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2